/*
**  $Source: WB_2.1:homes/rkr/prog/sercli/src/RCS/keywords.c,v $
**  $Author: rkr $
**  $Revision: 1.5 $
**  $Locker: rkr $
**  $State: Exp $
**  $Date: 1993/06/16 23:30:39 $
**
**  sercli (an Amiga .device <-> FIFO interface tool)
**  Copyright (C) 1993  Richard Rauch
**
**  See /doc/sercli.doc and /COPYING for use and distribution license.
**
*/

#include "config.h"
#include "keywords.h"

/*
**  This is a table describing the relationship between compile-time
**  symbols (see "keywords.h") and string constants that may appear in
**  config files and/or ARexx commands.  (Not all are valid in both
**  contexts).
**
*/

option keywords [] =
{
    {"id",              ID_STRING},

    {"device name",     DEVICE_NAME},
    {"device unit",     DEVICE_UNIT},

    {"bps",             SER_BPS},
    {"bits",            SER_BITS},
    {"sbits",           SER_STOP_BITS},
    {"7wire",           SER_7WIRE},
    {"3wire",           SER_3WIRE},
    {"xon/xoff",        SER_XON_XOFF},
    {"no xon/xoff",     SER_NO_XON_XOFF},
    {"shared",          SER_SHARED},
    {"exclusive",       SER_EXCLUSIVE},
    {"no rad boogie",   SER_NO_RAD_BOOGIE},
    {"rad boogie",      SER_RAD_BOOGIE},
    {"no parity",       SER_NO_PARITY},
    {"odd parity",      SER_ODD_PARITY},
    {"even parity",     SER_EVEN_PARITY},

    {"window title",    SET_WINDOW_TITLE},
    {"window size",     SET_WINDOW_SIZE},

    {"alert ser",       ALERT_SER},
    {"alert loc",       ALERT_LOC},
    {"no alert ser",    NO_ALERT_SER},
    {"no alert loc",    NO_ALERT_LOC},

    {"ser query",       SER_QUERY},

    {"", OPTION_NULL},
};

